smbclient
1

# smbclient

podobny do ftp klient do uzyskiwania dostępu do zasobów SMB/CIFS na serwerach

          smbclient
          nazwauslugi
          haslo
          -b rozmiarbufora
          -D katalog
          -U nazwauzytkownika
          -W gruparobocza
          -M <nazwa NetBIOS>
          -m max protokol
          -A plikautoryz
          -N
          -l pliklogu
          -L <nazwa NetBIOS>
          -I IP przezn
          -E <kod terminala>
          -c <tekst polecenia>
          -i zakres
          -O <opcje gniazda>
          -p port
          -R <kolejnosc odwzorowania nazw>
          -s <plik smb.conf>
          -T<c|x>IXFqgbNan

## OPIS

Ten program jest częścią pakietu Samba.

`smbclient` jest klientem który może "rozmawiać" z serwerem SMB/CIFS. Oferuje interfejs podobny do tego z programu ftp (zobacz `ftp(1)`). Wykonywane operacje obejmują takie rzeczy, jak ściąganie plików z serwera na maszynę lokalną, wysyłanie plików z maszyny lokalnej na serwer, pobieranie z serwera informacji o katalogu i tak dalej.

## OPCJE

nazwauslugi

  nazwauslugi jest nazwą usługi z której chcesz skorzystać na serwerze. Nazwa usługi przybiera formę `//serwer/usluga` gdzie `serwer` jest nazwą NetBIOS serwera SMB/CIFS oferującego żądaną usługę, a `usluga` jest nazwą oferowanej usługi. W ten sposób, żeby podłączyć się do usługi "drukarka" na serwerze SMB/CIFS "serwersmb", użyłbyś nazwyuslugi `//serwersmb/drukarka`

  Zauważ, że wymagana nazwa serwera NIE jest koniecznie nazwą hosta IP (DNS) serwera ! Wymagana nazwa jest nazwą NetBIOS serwera, która może być lub nie, taka sama jak nazwa hosta IP maszyny na której działa serwer.

  Nazwa serwera jest wyszukiwana albo stosownie do parametru `-R` przekazanego do `smbclient` , albo przy użyciu parametru `name resolve order` z pliku smb.conf, zezwalając administratorowi na zmianę kolejności i metod przy użyciu których nazwy serwerów są wyszukiwane.

haslo

  haslo jest hasłem wymaganym do tego, aby uzyskać dostęp do określonej usługi na określonym serwerze. Jeśli ten parametr jest dostarczony, zakładana jest opcja `-N` (wstrzymaj żądanie hasła) (tj.założenie jest takie, że opcja ta została włączona, przyp.tłum.).

  Nie ma domyślnego hasła. Jeśli żadne hasło nie jest dostarczone w linii poleceń (ani przy użyciu parametru, ani przez dodanie hasła do opcji `-U` (patrz poniżej)) i opcja `-N` nie jest podana, wówczas klient zażąda podania hasła, nawet jeśli żądana usługa nie wymaga tego. (Jeśli żadne hasł nie jest wymagane, po prostu naciśnij ENTER, żeby podać puste hasło).

  Uwaga: Niektóre serwery (włączając w to OS/2 i Windows for Workgroups) wymagają hasła pisanego dużymi literami. Małe lub "mieszane" litery w hasłach mogą być odrzucone przez te serwery.

  Bądź ostrożny z dołączaniem haseł do skryptów.

-s smb.conf

  Ten parametr określa ścieżkę dostępu do pliku konfiguracyjnego Samba, smb.conf. Plik ten kontroluje wszystkie aspekty ustawień Samby na danej maszynie, a smbclient również potrzebuje czytać ten plik.

-O opcje gniazda

  opcje gniazda TCP do ustawienia po stronie gniazda klienta. Zobacz parametr socket options na stronie podręcznika `smb.conf(5)`, aby obejrzeć listę poprawnych opcji.

-R kolejnosc odwzorowania nazw

  Ta opcja pozwala użytkownikowi programu `smbclient` określić jakich usług odwzorowania nazw ma używaź, gdy będzie szukał nazwy NetBIOS hosta do którego się podłącza.

  Opcje to: "lmhosts", "host", "wins" i "bcast". Powodują one, że nazwy odwzorowywane są następująco:

  - `lmhosts` : Szukaj adresu IP w pliku Samba lmhosts. Jeśli linia w pliku lmhosts nie ma żadnej nazwy dołączonej do nazwy NetBIOS (zobacz lmhosts(5) aby dowiedzieć się szczegółów) wtedy dowolna nazwa będzie pasować do poszukiwanej.

  - `host` : Wykonaj standardowe odwzorowanie nazwy hosta na adres IP, przy użyciu przeszukiwania systemowego pliku `/etc/hosts`, szukania NIS lub DNS. Ta metoda odwzorowania nazwy jest zależna od systemu operacyjnego. Przykładowo, w systemie IRIX lub Solaris może to być kontrolowane przez plik `/etc/nsswitch.conf`. Zauważ, że ta metoda jest użyta tylko, jeśli typ szukanej nazwy NetBIOS to typ 0x20 (serwer), w przeciwnym wypadku ta metoda będzie zignorowana.

  - `wins` : Zapytaj o nazwę pod adresem IP wymienionym w parametrze `wins server` w pliku smb.conf. Jeśli żaden serwer WINS nie został tam określony, ta metoda zostanie zignorowana.

  - `bcast` : Wykonaj rozgłaszanie na każdym ze znanych lokalnych interfejsów wymienionych w parametrze `interfaces` w pliku smb.conf. Jest to najmniej skuteczna spośród wszystkich metoda odwzorowania nazw, jako że zależy od istnienia docelowego hosta w lokalnie podłączonej podsieci.

  Jeśli ten parametr nie jest podany, wtedy użyta będzie kolejność odwzorowania nazw zdefiniowana w parametrze (`name resolve order` ) w pliku smb.conf.

  Domyślna kolejność to lmhosts, host, wins, bcast, i bez tego parametru oraz żadnego wpisu `name resolve order` w pliku `smb.conf`, metody odwzorowania nazw będą wypróbowywane w tej kolejności.

-M nazwa NetBIOS

  Ta opcja pozwala ci wysyłać wiadomości do innego komputera przy użyciu protokołu "WinPopup". Gdy tylko połączenie jest ustanowione, wpisujesz swoją wiadomość i naciskasz ^D (control-D) żeby zakończyć.

  Jeśli na odbierającym komputerze działa WinPopup, użytkownik odbierze wiadomość i prawdopodobnie piknięcie. Jeśli WinPopup nie działa, wiadomość zostanie utracona i nie wystąpi żaden komunikat błędu.

  Wiadomość jest również automatycznie skrócona jeśli jest większa niż 1600 bajtów, ponieważ jest to limit protokołu.

  Użyteczną sztuczką jest wysłanie wiadomości z cat poprzez `smbclient`. Na przykład: `cat mojawiadomosc.txt | smbclient -M FRED` wyśle wiadomość z pliku `mojawiadomosc.txt` do maszyny FRED.

  Możesz również zauważyć, że opcje `-U` i `-I` są użyteczne, ponieważ pozwalają one kontrolowaź części OD i DO wiadomośći.

  Zobacz parametr message command `smb.conf(5)`, aby obejrzeć opis jak odbierać przychodzące wiadomości WinPopup w Sambie.

  UWAGA: Skopiuj WinPopup do grupy startup ("autostart" w wersji polskiej, przyp.tłum.) w twoich pecetach z WfWg jeśli chcesz, żeby zawsze mogły odbierać wiadomości.

-i zakres

  To określa zakres NetBIOS którego smbclient użyje do komunikacji podczas generowania nazw NetBIOS. Po detale dotyczące użycia zakresów NetBIOS, zajrzyj do `rfc1001.txt` i `rfc1002.txt`. Zakresy NetBIOS są bardzo rzadko używane, więc ustawiaj ten parametr tylko jeśli jesteś administratorem wszystkich systemów NetBIOS z którymi się komunikujesz.

-N

  Jeśli jest określony, parametr ten wstrzymuje normalne żądanie hasła skierowane przez klienta do użytkownika. Jest to użyteczne podczas podłączania się do usługi która nie wymaga hasła.

  Jeśli hasło nie jest określone w linii poleceń lub ten parametr nie jest określony, klient zażąda hasła.

-n nazwa NetBIOS

  Domyślnie, klient użyje nazwy hosta lokalnej maszyny (w dużych literach) jako swojej nazwy NetBIOS. Ten parametr pozwala ci unieważnić nazwę hosta i użyć nazwy NetBIOS jakiejkolwiek zechcesz.

-d poziomdebugowania

  poziomdebugowania jest liczbą całkowitą od 0 do 10, lub literą 'A'.

  Domyślną wartością, jeśli ten parametr nie jest określony, jest zero.

  Im większa jest to wartość, tym więcej detali będzie logowanych w plikach logu na temat aktywności serwera. Na poziomie 0, tylko krytyczne błędy i poważne ostrzeżenia będą rejestrowane. Poziom 1 jest rozsądnym poziomem dla codziennego działania - generuje małą ilość informacji na temat wykonywanych operacji.

  Poziomy ponad 1 będą generować znaczne ilości informacji logu i powinny być używane tylko podczas śledzenia problemu. Poziomy ponad 3 są zaprojektowane tylko dla użytku developerów i generują OGROMNE ilości danych logu, w większości ekstremalnie zagadkowych. Jeśli poziomdebugowania jest ustawiony na literę 'A', wtedy wszystkie wiadomości debugowe będą wyświetlane. To ustawienie jest tylko dla developerów (i ludzi którzy naprawdę chcą wiedzieć jak pracuje kod wewnątrz).

  Zauważ, że określanie tego parametru tutaj unieważni parametr `log level` w pliku `smb.conf(5)`.

-p port

  Ta liczba jest numerem portu TCP który będzie użyty gdy będą wykonywane połączenia z serwerem. Standardowym (ogólnie znanym) numerem portu dla serwera SMB/CIFS jest 139, co jest wartością domyślną.

-l nazwaplikulogu

  Jeśli jest określona, nazwaplikulogu określa bazową nazwę pliku w którym dane operacyjne z działającego klienta będą logowane.

-l pliklogu

  Domyślna bazowa nazwa jest określona w czasie kompilacji.

  Nazwa bazowa jest używana do generowania właściwych nazw plików logu. Na przykład, jeśli określoną nazwą było "log", plikiem debugowym byłby log.klient.

  Wygenerowany plik logu nigdy nie jest usuwany przez klienta.

-h

  Wyświetl informację na temat użytkowania klienta.

-I adres IP

  adres IP jest adresem serwera do którego smbclient ma się podłączyć. Powinien być określony w standardowej notacji "a.b.c.d".

  Normalnie, klient spróbowałby zlokalizować nazwany serwer SMB/CIFS szukając go poprzez mechanizm rozwiązywania nazw NetBIOS opisany wyżej w parametrze `name resolve order`. Użycie tego parametru wymusi na kliencie założenie, że serwer jest na maszynie z określonym adresem IP i komponent zasobu który jest podłączany - nazwa NetBIOS - będzie zignorowany.

  Nie ma żadnych wartości domyślnych dla tego parametru. Jeśli nie dostarczony, będzie determinowany automatycznie przez klienta, jak opisano wyżej.

-E

  Ten parametr powoduje, że klient zapisuje komunikaty do standardowego strumienia błędów (stderr), zamiast do standardowego strumienia wyjściowego (stdout).

  Domyślnie, klient zapisuje wiadomości do standardowego wyjścia - typowo, do tty użytkownika.

-U nazwauzytkownika[%haslo]

  Ustawia nazwę SMB użytkownika lub nazwę użytkownika i hasło.

  Jeśli %hasło nie jest podane, użytkownik będzie o nie zapytany. Klient najpierw sprawdzi zmienną środowiskową `USER`, potem zmienną `LOGNAME` i jeśli ktoraś istnieje, jest konwertowana do dużych liter. Wszystko w tych zmiennych następujące po znaku &percnt; będzie traktowane jako hasło. Jeśli te zmienne nie zostaną znalezione, nazwą użytkownika jest `GUEST`.

  Jeśli hasło nie jest dołączone w tych zmiennych środowiskowych (przy użyciu składni %hasło), rpcclient poszuka zmiennej środowiskowej `PASSWD` z której odczyta hasło.

  Trzecią opcją jest użycie pliku referencji, który zawiera nazwę użytkownika i hasło jako czysty tekst. Ta opcja jest dostarczona przede wszystkim do skryptów w których admin nie chce podawać referencji w linii poleceń albo poprzez zmienne środowiskowe. Jeśli ta metoda zostanie użyta, upewnij się że uprawnienia do pliku ograniczają dostęp przed niechcianymi użytkownikami.

  Bądź ostrożny, co do umieszczania haseł w skryptach lub w zmiennej środowiskowej `CWPASSWD`. W wielu systemach linia poleceń działającego procesu może być widoczna poprzez komendę `ps`. Dla bezpieczeństwa zawsze pozwól programowi rpcclient, aby zapytał cię o hasło i wpisz je bezpośrednio.

-A <nazwapliku>

  Ta opcja pozwala ci określić plik z którego czytać nazwę użytkownika i hasło użyte w połączeniu. Format pliku to

      username = <wartosc>
      password = <wartosc>

  Upewnij się, że prawa dostępu do tego pliku ograniczają dostęp niechcianym uzytkownikom.

-L

  Ta opcja pozwala ci zobaczyć jakie usługi są dostępne na serwerze. Użyjesz jej jako `smbclient -L host` i lista powinna się pojawić. Opcja `-I` może być użyteczna, jeśli twoje nazwy NetBIOS nie pasują do twoich nazw hostów tcp/ip dns lub jeśli próbujesz dosięgnąć hosta w innej sieci.

-t kod terminala

  Ta opcja mówi programowi smbclient jak interpretować nazwy plików przychodzące od zdalnego serwera. Zwykle, wielobajtowe UNIX'owe implementacje języków azjatyckich używają innego zestawu znaków, niż serwery SMB/CIFS (na przykład EUC zamiast SJIS). Ustawianie tego parametru pozwoli programowi smbclient poprawnie konwertowaź pomiędzy nazwami plików UNIX i SMB. Ta opcja nie była solidnie przetestowana i może mieć pewne problemy.

  Kody terminali zawierają CWsjis, CWeuc, CWjis7, CWjis8, CWjunet, CWhex, CWcap. Nie jest to kompletna lista. Sprawdź kody źródłowe Samby, żeby obejrzeć kompletną listę.

-b rozmiarbufora

  Ta opcja zmienia rozmiar bufora nadawczo-odbiorczego podczas pobierania lub wysyłania pliku z/do serwera. Domyślnie jest to 65520 bajtów. Przy ustawianiu tej wartości na mniejszą (do 1200 bajtów) zaobserwowano, że szybkość transferu plików do i z serwera Win9x wzrastała.

-W GRUPAROBOCZA

  Unieważnia domyślną grupę roboczą określoną w parametrze workgroup w pliku `smb.conf`, dla tego połączenia. Może to być potrzebne, żeby podłączyć się do niektórych serwerów.

-T opcje tar

  smbclient może być użyty do tworzenia backupów kompatybilnych z programem `tar(1)`, wszystkich plików na współdzielonym zasobie SMB/CIFS. Dodatkowe flagi tar które mogą być podane, to:

  - `c` - Utwórz plik tar w UNIX'ie. Musi po nim następować nazwa pliku tar, użądzenia taśmowego, lub CW"-" dla standardowego wyjścia. Używając standardowego wyjścia musisz włączyć poziom debugowania na najniższą wartość CW-d0, żeby uniknąć uszkodzenia twojego pliku tar. Ta flaga jest wzajemnie wykluczająca dla flagi `x`.

  - `x` - Ekstraktuj (przywróć) lokalny plik tar z powrotem do współudziału. Jeśli opcja -D nie jest podana, pliki tar będą przywracane z najwyższego poziomu zasobu. Za nią musi być podana nazwa pliku tar, użądzenia, lub "-" dla standardowego wejścia. Wzajemnie wykluczająca flagę `c`. Przywrócone pliki mają datę utworzenia (mtime) ustawioną na datę zachowaną w pliku tar. Katalogi nie mają obecnie poprawnie przywracanej daty utworzenia.

  - `I` - Dołącz pliki i katalogi. Jest domyślnym zachowaniem, gdy nazwy plików są podane powyżej. Powoduje, że pliki tar są dołączane w trakcie ekstrakcji lub tworzenia (i dlatego też wszystko inne jest wykluczane). Zobacz przykład poniżej. Globbing nazw plików działa w jeden z dwóch sposobów. Zobacz `r` poniżej.

  - `-X` - Wyklucz pliki i katalogi. Powoduje, że pliki tar są wykluczane z ekstrakcji lub tworzenia. Zobacz przykład poniżej. Globbing nazw plików działa teraz w jeden z dwóch sposobów. Zobacz `r` poniżej.

  - `-b` - Rozmiar bloku. Musi za nim następować poprawny (większy od zera) rozmiar bloku. Powoduje, że plik tar jest zapisywany w blokach rozmiarbloku*TBLOCK (zazwyczaj 512 bajtów).

  - `-g` - Przyrostowy. Dokonuj backupu jedynie plików z ustawionym bitem archive. Użyteczne tylko z flagą `c`.

  - `-q` - Cicho. Powstrzymuje tar'a przed wypisywaniem diagnostyki podczas działania. Jest to to samo, co tryb "quiet" w tar.

  - `-r` - Wyrażenie regularne dołączania lub wykluczania. Używa dopasowywania wyrażenia regularnego do wykluczania plików jeśli jest skompilowany z HAVE_REGEX_H. Jednakże, tryb ten może być bardzo powolny. Jeśli nie jest skompilowany z HAVE_REGEX_H, wykonuje ograniczone dopasowanie z * i ? .

  - `N` - Nowszy niż. Musi za nim następować nazwa pliku którego data jest porównywana podczas tworzenia, do plików umieszczonych we współudziale. Tylko pliki nowsze niż podany plik, są backupowane do pliku tar. Użyteczne tylko z flagą `c`.

  - `a` - Ustaw bit archive. Powoduje, że bit archive jest resetowany, gdy plik jest backupowany. Użyteczne z flagami `g` i `c`.

  Długie Nazwy Plików Tar

  Opcja tar `smbclient'a` wspiera teraz długie nazwy plików zarówno przy archiwizowaniu, jak i przywracaniu. Jednakże pełna ścieżka dostępu do pliku musi być mniejsza niż 1024 bajty. Oprócz tego, gdy archiwum tar jest tworzone, opcja tar smbclient'a umieszcza w archiwum wszystkie pliki z nazwami względnymi, a nie z bezwzględnymi.

  Nazwy Plików Tar

  Wszystkie nazwy plików mogą być podane jako DOSowe śceżki dostępu (z '\' jako separator) lub UNIXowe (z '/' jako separator).

  Przykłady

  Przywróć z pliku tar backup.tar do mojwspoludzial na mojpc (bez hasła na współudziale)

  `smbclient //mojpc/mojwspoludzial "" -N -Tx backup.tar`

  Przywróć wszystko z wyjątkiem `uzytkownicy/dokumenty`

  `smbclient //mojpc/mojwspoludzial "" -N -TXx backup.tar uzytkownicy/dokumenty`

  Stwórz plik tar z plików pod katalogami `uzytkownicy/dokumenty`.

  `smbclient //mojpc/mojwspoludzial "" -N -Tc backup.tar uzytkownicy/dokumenty`

  Stwórz taki sam plik tar jak wyżej, ale teraz użyj ścieżki DOS

  `smbclient //mojpc/mojwspoludzial "" -N -tc backup.tar uzytkownicy\dokumenty`

  Stwórz plik tar ze wszystkich plików i katalogów we współudziale

  `smbclient //mojpc/mojwspoludzial "" -N -Tc backup.tar *`

-D katalog poczatkowy

  Zmień katalog na początkowy przed startem. Ma jakieś zastosowanie prawdopodobnie tylko z opcją tar -T.

-c łańcuch polecenia

  łańcuch polecenia jest listą poleceń, odzielonych średnikami, do wykonania, zamiast wpisywania ich ze znaku zachęty (ang. prompt). `-c` implikuje `-N` .

  Jest to szczególnie użyteczne w skryptach i do wyświetlania standardowego wejścia na serwer, np. `-c 'print -'.`

## OPERACJE

Gdy tylko klient działa, użytkownikowi prezentowany jest znak zachęty :

smb:\>

Backslash (po polsku znany również jako "w-tył-ciach", przyp.tłum.) wskazuje na bieżący katalog roboczy na serwerze i zmieni się, jeśli bieżący katalog roboczy zostanie zmieniony.

Znak zachęty wskazuje, że klient jest gotowy i czeka, aby wypełnić polecenie użytkownika. Każde polecenie jest pojedynczym słowem, z opcjonalnymi, następującymi po nim parametrami specyficznymi dla tego polecenia. Polecenia i parametry są ograniczone spacjami chyba, że opisy określają inaczej. Wszystkie polecenia mogą być z dużej lub małej litery. Parametry do poleceń mogą lub nie, być pisane z dużej/małej litery, zależnie od polecenia.

Możesz podawaź nazwy plików zawierające spacje poprzez ich cytowanie w cudzysłowach, na przykład "długa nazwa pliku".

Parametry pokazane w nawiasach kwadratowych (np, "[parametr]") są opcjonalne. Jeśli nie są podane, polecenie użyje odpowiednich wartości domyślnych. Parametry pokazane w nawiasach kątowych (np, "<parametr>") są wymagane.

Zauważ, że wszystkie polecenia operujące na serwerze są właściwie wykonywane przez wysyłanie do serwera żądania. W ten sposób, zachowanie może różnić się od serwera do serwera, zależnie od tego, jak serwer był zaimplementowany.

Dostępne polecenia są podane tutaj w kolejności alfabetycznej.

? [polecenie]

  Jeśli "polecenie" jest podane, komenda ? wyświetli krótki komunikat informacyjny o określonym poleceniu. Jeśli żadne polecenie nie jest określone, zostanie wyświetlona lista dostępnych.

! [polecenie powloki]

  Jeśli "polecenie powloki" jest określone, komenda ! wykona lokalnie powłokę i uruchomi jej określone polecenie. Jeśli żadne polecenie nie jest określone, zostanie uruchomiona lokalna powłoka.

cd [nazwa katalogu]

  Jeśli "nazwa katalogu" jest określona, bieżący katalog roboczy na serwerze będzie zmieniony na określony w poleceniu. Operacja ta zakończy się niepowodzeniem jeśli, z jakichś powodów, określony katalog jest niedostępny.

  Jeśli żadna nazwa katalogu nie jest określona, zostanie podany bieżący katalog roboczy na serwerze.

del <mask>

  Klient zażąda, żeby serwer spróbował usunąć wszystkie pliki pasujące do "maski" z bieżącego katalogu roboczego na serwerze.

dir <maska>

  Lista plików pasujących do maski w bieżącym katalogu roboczym na serwerze będzie pobrana z serwera i wyświetlona.

exit

  Zakończ połączenie z serwerem i wyjdź z programu.

get <nazwa odległego pliku> [nazwa lokalnego pliku]

  Skopiuj plik o nazwie "nazwa odległego pliku" z serwera na maszynę na której działa klient. Jeśli określone, nazwij lokalną kopię "nazwa lokalnego pliku". Zauważ, że wszystkie transfery w `smbclient` są binarne. Zobacz również polecenie lowercase.

help [polecenie]

  Zobacz wyżej polecenie ?.

lcd [nazwa katalogu]

  Jeśli "nazwa katalogu" jest określona, bieżący katalog roboczy na lokalnej maszynie będzie zmieniony na katalog określony w poleceniu. Ta operacja zakończy się niepowodzeniem jeśli z jakiegoś powodu określony katalog jest niedostępny.

  Jeśli nie zostanie określona żadna nazwa katalogu, nazwa bieżącego katalogu roboczego na lokalnej maszynie zostanie podana.

lowercase

  Przełącz przetwarzanie nazw plików do małych liter dla poleceń get i mget.

  Jeśli przetwarzanie nazw na małe litery jest WłąCZONE, lokalne nazwy plików są konwertowane do małych liter podczas używania poleceń get i mget. Jest to często użyteczne, podczas kopiowania (powiedzmy) plików MSDOS z serwera, ponieważ nazwy plików w małych literach są normą w systemach UNIX.

ls <maska>

  Zobacz wyżej polecenie dir.

maska <maska>

  Ta komenda pozwala użytkownikowi ustawić maskę która będzie używana podczas rekursywnych operacji poleceniami mget i mput.

  Maski określone dla poleceń mget i mput funkcjonują jako filtry dla katalogów, zamiast dla plików, gdy rekursja jest włączona. Maska określona poleceniem mask jest niezbędna do filtrowania plików w tych katalogach. Przykładowo, jeśli maska określona w poleceniu mget to "zrodło*" i maska określona w poleceniu mask to "*.c" oraz rekursja jest włączona, polecenie mget pobierze wszystkie pliki pasujące do "*.c" we wszystkich katalogach w dół, włącznie z wszystkimi katalogami pasującymi do "source*" w bieżącym katalogu roboczym.

  Zauważ, że wartość maski to domyślnie maska pusta (równoważna z "*") i pozostaje taka, dopóki polecenie mask nie będzie użyte, żeby ją zmienić. Zatrzymuje ona ostatnio podaną wartość na czas nieokreślony. Aby uniknąć niespodziewanych rezultatów byłoby mądrze zmienić wartość maski z powrotem na "*" po użyciu poleceń mget lub mput.

md <nazwa katalogu>

  Zobacz polecenie mkdir.

mget <maska>

  Skopiuj wszystkie pliki pasujące do maski z serwera na maszynę, na której działa klient.

  Zauważ, że maska jest interpretowana inaczej w czasie rekursywnych i nierekursywnych operacji - odnieś się do poleceń recurse i mask po więcej informacji. Zauważ, że wszystkie transfery w smbclient są binarne. Zobacz również polecenie lowercase.

mkdir <nazwa katalogu>

  Utwórz nowy katalog o określonej nazwie, na serwerze (zezwalającym na prawa dostępu użytkownika).

mput <maska>

  Skopiuj wszystkie pliki pasujące do maski w bieżącym katalogu roboczym na lokalnej maszynie, na bieżący katalog roboczy na serwerze.

  Zauważ, że maska jest interpretowana inaczej w czasie rekursywnych i nierekursywnych operacji - odnieś się do poleceń recurse i mask po więcej informacji. Zauważ, że wszystkie transfery w smbclient są binarne. Zobacz również polecenie lowercase.

print <nazwa pliku>

  Wydrukuj określony plik z lokalnej maszyny poprzez usługę drukowalną na serwerze.

  Zobacz również polecenie printmode.

printmode <graphics lub text>

  Ustaw tryb drukowania, aby dopasować się albo do danych binarnych (takich jak informacje graficzne), albo do tekstu. Następne polecenia wydruku będą używać aktualnego trybu drukowania.

prompt

  Przełącz potwierdzanie nazw plików podczas operacji wykonywanych przez polecenia mget i mput.

  Gdy włączone, użytkownik będzie proszony o potwierdzenie transferu każdego pliku podczas tych poleceń. Gdy wyłączone, wszystkie określone pliki będą transferowane bez potwierdzania.

put <nazwa pliku lokalnego> [nazwa pliku odległego]

  Skopiuj plik o nazwie "nazwa pliku lokalnego" z maszyny na której działa klient, na serwer. Jeśli jest podana, nazwij zdalną kopię "nazwa pliku odległego". Zauważ, że wszystkie transfery w smbclient są binarne. Zobacz również polecenie lowercase.

queue

  Wyświetla kolejkę wydruku, pokazując id zadania, nazwę, rozmiar i aktualny status.

quit

  Zobacz polecenie exit.

rd <nazwa katalogu>

  Zobacz polecenie rmdir.

recurse

  Przełącz rekursję katalogów dla poleceń mget i mput.

  Gdy włączona, polecenia te będą przetwarzać wszystkie katalogi w katalogu źródłowym (tj, katalog z którego kopiują) i będą to robić rekursywnie dla każdego, który pasuje do określonej w poleceniu maski. Tylko pliki które pasują do maski okeślonej poleceniem mask będą pobierane. Zobacz również polecenie mask.

  Gdy rekursja jest wyłączona, tylko pliki z bieżącego katalogu roboczego na źródłowej maszynie, które pasują do maski określonej dla poleceń mget lub mput będą skopiowane, a każda maska określona poleceniem mask będzie ignorowana.

rm <maska>

  Usuń wszystkie pliki pasujące do maski z bieżącego katalogu roboczego na serwerze.

rmdir <nazwa katalogu>

  Usuń określony katalog (zezwalający użytkownikowi na dostęp) z serwera.

tar <c|x>[IXbgNa]

  Przeprowadza operację tar - zobacz opcję linii komend `-T` wyżej. Na jej zachowanie może mieć wpływ polecenie tarmode (zobacz niżej). Użycie g (przyrostowo) i N (nowsze) będzie miało wpływ ma ustawienia tarmode. Zauważ, że użycie opcji "-" z tar x może nie działać - zamiast tego sposobu, użyj opcji linii komend.

blocksize <rozmiarbloku>

  Rozmiar bloku. Musi następować po nim poprawna (większa od zera) wielkość bloku. Powoduje, że plik tar jest zapisywany w blokach rozmiarbloku*TBLOCK (zazwyczaj 512 bajtów).

tarmode <full|inc|reset|noreset>

  Zmienia zachowanie programu tar zważając na bity archive. W trybie full, tar wykona archiwizację wszystkiego niezależnie od ustawienia bitu archive (to jest tryb domyślny). W trybie przyrostowym (inc), tar wykona archiwizację tylko plików z ustawionym bitem archive. W trybie reset, tar wykona reset bitu archive na wszystkich plikach które archiwizuje (implikuje to współudział do zapisu/odczytu).

setmode <nazwapliku> <zezw=[+|\-]rsha>

  Wersja komendy DOS attrib do ustawiania praw dostępu do pliku. Na przykład:

  `setmode mojplik +r`

  zrobiłby plik tylko do odczytu

## NOTATKI

Niektóre serwery są wybredne co do wielkości liter w dostarczanych nazwach użytkowników, hasłach, nazwach współudziałów (nazwach usług) i nazwach maszyn. Jeśli nie uda ci się podłączyć, spróbuj podając wszystkie parametry w dużych literach.

Często niezbędne jest użycie opcji `-n` podczas podłączania się do niektórych typów serwerów. Przykładowo OS/2 LanManager domaga się użycia poprawnej nazwy NetBIOS, więc potrzebujesz dostarczyć poprawną nazwę która będzie znana serwerowi.

smbclient wspiera długie nazwy plików tam, gdzie serwer wspiera protokół LANMAN2 lub wyższy.

## ZMIENEN ŚRODOWISKOWE

Zmienna `USER` może zawierać nazwę użytkownika osoby używającej klienta. Ta informacja jest używana tylko, gdy poziom protokołu jest wystarczająco wysoki, żeby wspierać hasła na poziomie sesji.

Zmienna `PASSWD` może zawierać hasło osoby używającej klienta. Ta informacja jest używana tylko, jeśli poziom protokołu jest wystarczająco wysoki, żeby wspierać hasła na poziomie sesji.

## INSTALACJA

Lokalizacja programu klienta jest w gestii indywidualnych administratorów systemów. W ten sposób poniżej są tylko sugestie.

Jest zalecanym, aby oprogramowanie smbclient było zainstalowane w katalogu `/usr/local/samba/bin` lub `/usr/samba/bin`. Katalog ten powinien móc być czytany przez wszystkich, zapisywany tylko przez root'a. Sam program klient powinien być wykonywalny przez wszystkich. Klient >NIE powinien być setuid lub setgid !

Pliki logu klienta powinny być wkładane do katalogu czytanego i zapisywanego tylko przez użytkownika.

Aby przetestować klienta, będziesz potrzebował znać nazwę działającego serwera SMB/CIFS. Jest możliwe uruchomienie `smbd(8)` przez zwykłego użytkownika - taki serwer jako demon na porcie dostępnym dla użytkownika (typowo, każdy numer portu powyżej 1024) dostarcza wygodnego serwera testowego.

## DIAGNOSTYKA

Większość informacji diagnostycznych wydawanych przez klienta jest logowanych w określonym pliku logu. Nazwa pliku logu jest określana w czasie kompilacji, ale może być unieważniona w linii komend.

Liczba i natura dostępnych informacji diagnostycznych zależy od poziomu debugowania używanego przez klienta. Jeśli masz problemy, ustaw poziom debugowania na 3 i reużytkuj plik logu.

## WERSJA

Ta strona podrecznika jest poprawna dla wersji 2.2 pakietu Samba.

## AUTOR

Pierwotnie, Samba i związane z nią oprogramowanie były stworzone przez Andrew Tridgella. Samba jest teraz rozwijana przez Zespół Samba jako projekt Open Source podobnie jak jądro Linux.

Pierwotnie, strony podręcznika Samba zostały napisane przez Karla Auera. Kody źródłowe tych stron zostały przekonwertowane do formatu YODL (kolejny świetny kawałek oprogramowania Open Source dostępny na ftp://ftp.icce.rug.nl/pub/unix/) a zaktualizowane do wydania 2.0 Samby przez Jeremy Allison'a. Konwersja do DocBook dla Samba 2.2 została wykonana przez Geralda Cartera. Tłumaczenie na język polski i konwersję polskiej wersji do DocBook wykonał Rafał Szcześniak.